package com.jz.common.interceptor;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.access.ConfigAttribute;
import org.springframework.security.web.FilterInvocation;
import org.springframework.security.web.access.intercept.FilterInvocationSecurityMetadataSource;
import org.springframework.security.web.util.matcher.AntPathRequestMatcher;
import org.springframework.stereotype.Component;

//import com.jz.dmp.web.ui.modules.sys.repository.domain.DmpSystemMenu;
//import com.jz.dmp.web.ui.modules.sys.service.DmpSystemMenuService;

/** 
* @ClassName: MyInvocationSecurityMetadataSource
* @Description: TODO(这里用一句话描述这个类的作用) 
* @author ybz 
* @date 2017年12月15日 下午5:54:15 
*  
*/
@Component
public class MyInvocationSecurityMetadataSource implements FilterInvocationSecurityMetadataSource {
	
	private static final Logger logger = LoggerFactory.getLogger(MyInvocationSecurityMetadataSource.class);
	
	private boolean isExpire;//加载资源是否过期
	
	//@Autowired
	//private DmpSystemMenuService dspSystemMenuService;
	
	private Map<String, Collection<ConfigAttribute>> map = null;
	
	//加载权限表中所有权限
	@SuppressWarnings("unused")
	public void loadResourceDefine(){
		map = new HashMap<>();
		Collection<ConfigAttribute> configAttributes;
		ConfigAttribute cfg;
		
		System.err.println("1234444444444444444--------------------");
		/*List<DmpSystemMenu> resources = dspSystemMenuService.findAllList();
		for (DmpSystemMenu dspSystemMenu : resources) {
			configAttributes = new ArrayList<>();
			cfg = new SecurityConfig(dspSystemMenu.getMenuTarget());
			//此处只添加了用户的名字，其实还可以添加更多的权限信息，例如请求方法到ConfigAttribute的集合中去。
			//此处添加的信息将会作为MyAccessDecisionManager类的decide的第三个参数。
			configAttributes.add(cfg);
			//用权限的getUrl()作为map的key，用configAttribute的集合作为value。
			map.put(dspSystemMenu.getMenuHref(), configAttributes);
			
		}*/
		
	}

	@Override
	public Collection<ConfigAttribute> getAllConfigAttributes() {
		// TODO Auto-generated method stub
		return null;
	}

	//此方法是为了判定用户请求的url是否在权限表中，如果在权限表中，则返回给decide方法，用来判定用户是否有此权限。如果不在权限表中则放行。
	@Override
	public Collection<ConfigAttribute> getAttributes(Object object) throws IllegalArgumentException {
		
		if (map == null || isExpire) {//如果map为null 或者资源过期，则重新加载资源
			logger.info("资源重新加载...");
			loadResourceDefine();
			isExpire = false;
		}
		//object中包含用户请求的request信息
		HttpServletRequest request = ((FilterInvocation)object).getHttpRequest();
		AntPathRequestMatcher matcher;
		String resUrl;
		for (Entry<String, Collection<ConfigAttribute>> entry : map.entrySet()) {
			resUrl = entry.getKey();
			matcher = new AntPathRequestMatcher(resUrl);
			if (matcher.matches(request)) {
				return entry.getValue();
			}
		}
		
		return null;
	}

	@Override
	public boolean supports(Class<?> arg0) {
		// TODO Auto-generated method stub
		return true;
	}

	/** 
	* @Title: setExpire 
	* @Description: TODO(设置是否过期) 
	* @param @param isExpire    设定文件 
	* @return void    返回类型 
	* @throws 
	*/
	public void setExpire(boolean isExpire) {
		this.isExpire = isExpire;
	}

}
