package com.jz.dmp.modules.service.impl;

import com.jz.dmp.modules.dao.DvRuleTDao;
import com.jz.dmp.modules.model.DvRuleT;
import com.jz.dmp.modules.service.DvRuleTService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * ???(DvRuleT)表服务实现类
 *
 * @author Bellamy
 * @since 2020-12-24 10:56:18
 */
@Service("dvRuleTService")
public class DvRuleTServiceImpl implements DvRuleTService {
    @Autowired
    private DvRuleTDao dvRuleTDao;

    /**
     * 通过ID查询单条数据
     *
     * @param ruleId 主键
     * @return 实例对象
     */
    @Override
    public DvRuleT queryById(Long ruleId) {
        return this.dvRuleTDao.queryById(ruleId);
    }

    /**
     * 查询多条数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    @Override
    public List<DvRuleT> queryAllByLimit(int offset, int limit) {
        return this.dvRuleTDao.queryAllByLimit(offset, limit);
    }

    /**
     * 新增数据
     *
     * @param dvRuleT 实例对象
     * @return 实例对象
     */
    @Override
    public DvRuleT insert(DvRuleT dvRuleT) {
        this.dvRuleTDao.insert(dvRuleT);
        return dvRuleT;
    }

    /**
     * 修改数据
     *
     * @param dvRuleT 实例对象
     * @return 实例对象
     */
    @Override
    public DvRuleT update(DvRuleT dvRuleT) {
        this.dvRuleTDao.update(dvRuleT);
        return this.queryById(dvRuleT.getRuleId());
    }

    /**
     * 通过主键删除数据
     *
     * @param ruleId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Long ruleId) {
        return this.dvRuleTDao.deleteById(ruleId) > 0;
    }
}